#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                    Trend_Trigger_Modified_v3.mq4 |
//| Modified version of Trend Trigger Factor by mikesbon (thanks to perkyz)|
//|                                                                  |
//|                                        Converted by Mql2Mq4 v1.1 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Paul Y. Shimada"
#property link      " PaulYShimada@Y..."

#property indicator_separate_window
#property indicator_color1 SkyBlue
#property indicator_buffers 2
#property indicator_color2 LightSeaGreen

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double TTFbars = 15;
extern double t3_period = 5;
extern double b = 0.7;
extern double mode_0Sep_1Main = 0;
extern double barBegin = 1000;
extern double show_Info = 0;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(1, ExtHistoBuffer2);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
string IndicatorName = "py.TTF";
string Version = "S01";
double HighestHighRecent = 0;
double HighestHighOlder = 0;
double LowestLowRecent = 0;
double LowestLowOlder = 0;
double BuyPower = 0;
double SellPower = 0;
double TTF = 0;
double t3 = 0;
double e1 = 0;
double e2 = 0;
double e3 = 0;
double e4 = 0;
double e5 = 0;
double e6 = 0;
double c1 = 0;
double c2 = 0;
double c3 = 0;
double c4 = 0;
double r = 0;
double w1 = 0;
double w2 = 0;
double b2 = 0;
double b3 = 0;
int shift = 0;
double count = 0;
bool is_First = True;
double loopBegin = 0;
double prevBars = 0;
double PrevTime = 0;
double tick = 0;
double prevShift = 99999;
double badPlotBars = 0;
double firstPlotBar = 0;
double CheckSum = 0;
double CheckSumPrev = 0;
string Msg = "";

/*[[
	Name := Trend Trigger Modified
	Reference := Technical Analysis of Stocks and Commodities, Dec. 2004,p.28. M.H. Pee
	TTF Author := Paul Y. Shimada
	Link := PaulYShimada@Y...
	Notes := Modified version of Trend Trigger Factor by mikesbon (thanks to perkyz)
	Separate Window := Yes
	First Color := SkyBlue
	First Draw Type := Line
	First Symbol := 217
	Use Second Data := Yes
	Second Color :=  LightSeaGreen
	Second Draw Type := Line
	Second Symbol := 218
]]*/

 //15=default number of bars for computation.


 //0=Separate window Line (with dual trigger), 1=Main window Histogram (colored bars).
 //<1000 recommended for faster speed, 0=All bars computed & plotted.
 //0=Hide on-chart Info, 1=Show on-chart Info & Print Tick Data to Journal, -1=NEVER show.

// Variable Specific:


























// Variable Generic, mostly for module flow control:








 //Discarded first (old) bars with bad computed values





b2 = b * b;
b3 = b2 * b;
c1 = (-b3);
c2 = (3 * (b2 + b3));
c3 = (-3) * (2 * b2 + b + b3);
c4 = (1 + 3 * b + b3 + 3 * b2);

r = t3_period;

if( r < 1 ) r = 1;
r = 1 + 0.5 * (r - 1);
w1 = 2 / (r + 1);
w2 = 1 - w1;

/*======================*/
/* Begin Pre-Loop Setup */
/*======================*/
//Check for additional bars loading or total reloadng.
if( Bars < prevBars || Bars - prevBars > 1 ) is_First = True;
prevBars = Bars;

//Have any Inputs changed?
CheckSum = TTF + mode_0Sep_1Main + barBegin + show_Info;   
 
if( CheckSum != CheckSumPrev ) is_First = True;
CheckSumPrev = CheckSum;
//--------------------------------------------------------------------

if( is_First ) 
{ 	/*This block executes ONLY First Time for each Attachment-To-Chart. If MT is closed or another Profile is selected, 
	the values & parameters for this module are saved, and when MT or this Profile is restarted, it would not be the First 
	Time Attachment-To-Chart. So this block would not execute unless the value of "Bars" has changed. */
	SetLoopCount(0);

	/*==============*/
	/* Check Inputs */
	/*==============*/
	if( 0 > TTFbars || TTFbars > 299 ) 
		{ 
		Msg = IndicatorName + " **Input Error** :" + " TTFbars must be between 0 and 300. Cannot=" + TTFbars;
		return(0);
		}
	
	if( mode_0Sep_1Main != 0 && mode_0Sep_1Main != 1 ) 
		{ 
		Msg = IndicatorName + " **Input Error** : " + " and mode_0Sep_1Main must be {0,1}. Cannot=" + mode_0Sep_1Main;
		Alert(Msg);
		return(0);
		}

	//Comment to display IndicatorName & parameters
	Msg = IndicatorName + ".v" + Version + "(" + TTFbars + ")";
	Print(Msg);
	if( show_Info != (-1) ) Comment(Msg);

	//Usage
	if( show_Info ==  1 ) Comment(Msg 
		+ " Trend Trigger Factor (TTF)"
		+ "'#10'User-Inputs:" 
		+ "'#10'TTFbars:"
		+ "'#10'15=default Number of bars for computation."
		+ "'#10'mode_0Sep_1Main:"
		+ "'#10'0=Separate window Line with dual trigger"
		+ "'#10'TTF>+100 = Long"
		+ "'#10'TTF<-100 = Short"
		+ "'#10'Else=Ranging"
		+ "'#10'1=Main window Histogram with colored bars"
		+ "'#10'barBegin:"
		+ "'#10'<1000 recommended for faster computation"
		+ "'#10'0=All bars computed & plotted (slower)"
		+ "'#10'show_Info:"
		+ "'#10'0=Hide on-chart Info"
		+ "'#10'1=Show on-chart Info & Print Tick data to Journal"
		+ "'#10'-1=Never show Comments");

	//BarIndexNumber=shift=Bars-1..0
	if( barBegin > 0 && barBegin < Bars - 1 ) loopBegin = barBegin ; else loopBegin = Bars - 1; 

	/*===================================*/
	/* Specific for particular indicator */
	/*===================================*/
	loopBegin = loopBegin - TTFbars; //Cannot compute early bars
	/* end Specific */

	is_First = False;
} //if is_First

/*======================*/
/* end Pre-Loop Setup */
/*======================*/
loopBegin = loopBegin + 1; //Replot previous bar
for(shift =loopBegin;shift >=0;shift --)
{
	/*=================================*/
	/* Standard Specific Computations */
	/*=================================*/
	HighestHighRecent = High[Highest(MODE_HIGH,shift,TTFbars)];
	HighestHighOlder = High[Highest(MODE_HIGH,shift + TTFbars,TTFbars)];
	LowestLowRecent = Low [Lowest(NULL, 0, MODE_LOW,shift,TTFbars)];
	LowestLowOlder = Low [Lowest(NULL, 0, MODE_LOW,shift+TTFbars,TTFbars)];
	BuyPower = HighestHighRecent - LowestLowOlder;
	SellPower = HighestHighOlder - LowestLowRecent;
	TTF = (BuyPower - SellPower) / (0.5 * (BuyPower + SellPower)) * 100;

	e1 = w1 * TTF + w2 * e1;
	e2 = w1 * e1 + w2 * e2;
	e3 = w1 * e2 + w2 * e3;
	e4 = w1 * e3 + w2 * e4;
	e5 = w1 * e4 + w2 * e5;
	e6 = w1 * e5 + w2 * e6;

	TTF = c1 * e6 + c2 * e5 + c3 * e4 + c4 * e3;
	SetIndexValue(shift,TTF);

	switch( mode_0Sep_1Main
		) {
		case 0: //Separate window Line (with dual trigger)
		SetIndexValue(shift,TTF);
		//Dual value trigger +/-100
		if( TTF >= 0 ) SetIndexValue2(shift,50) ; else SetIndexValue2(shift,(-50));

	
		loopBegin = loopBegin - 1;
}
  return(0);
}